<?php

namespace App\Console\Commands;

use App\Repositories\Enums\ModelStatusEnum;
use App\Repositories\Models\Base\Resource;
use App\Repositories\Models\Course\Chapter;
use App\Repositories\Models\Course\Course;
use App\Repositories\Models\Course\Video;
use Carbon\Carbon;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Redis;
use Illuminate\Support\Str;

/**
 * Class PresenterCommand
 * @package Prettus\Repository\Generators\Commands
 * @author Anderson Andrade <contato@andersonandra.de>
 */
class InitCourseCommand extends Command
{

    public static $COURSE_MAPS = [
        '中医基础理论' => [
            'name' => 'zhongyililunjichu',
            'chapter' => [
                '绪论' => 'introduction',
                '哲学基础' => 'philosophical-basis',
                '藏象' => 'zangxiang',
                '精 气 血 津液' => 'bodyfluid',
                '经络' => 'jingluo',
                '体质' => 'constitution',
                '病因' => 'pathogeny',
                '病机' => 'bingji',
                '养生防治' => 'health',
            ]
        ]
    ];
    /**
     * The name of command.
     *
     * @var string
     */
    protected $name = 'init:test';
    /**
     * The description of command.
     *
     * @var string
     */
    protected $description = 'Create a new course.';
    /**
     * The type of class being generated.
     *
     * @var string
     */
    protected $type = 'course';

    /**
     * Execute the command.
     *
     * @return void
     * @see fire()
     */
    public function handle()
    {
        $this->loadFiles();
        $this->line('ok');
    }

    public function loadFiles()
    {
//        $base_path = '/home/www/platform-api/storage/app/public/course_video/zhongyililunjichu-en';
//        $base_path = '/Volumes/希梦耐康科技/中医基础理论/中医基础理论';
//        $filesInFolder = File::files($base_path);
//        $videos = [];
//        $i = 0;
//        foreach ($filesInFolder as $path) {
//            $file = pathinfo($path);
//            $video = [
//                'section' => 0,
//                'video' => false,
//                'video_path' => false,
//                'srt' => false,
//            ];
//            if ($file['extension'] == 'mp4') {
//                $video['video'] = $file['filename'];
//                $video['video_path'] = 'zhongyililunjichu-en/' . $file['filename'] . '.mp4';
//                $nums = substr($video['video'], 0, 1);
//                $video['section'] = $nums;
//                $is_exists = File::exists($base_path . '/' . $file['filename'] . '.srt');
//                if ($is_exists) {
//                    $video['srt'] = $file['filename'] . '.srt';
//                    $video['srt_path'] = 'course_video/zhongyililunjichu-en/' . $file['filename'] . '.srt';
//                    $i++;
//                }
//                $i++;
//                $videos[$nums][] = $video;
////                $videos[] = $video;
//            }
//        }
////        $this->table(['section', 'name', 'path', 'srt'], $videos);
////        dd(1);
//
//        //创建课程
//        $course = Course::query()->find(1);
////        $course->fill([
////            'title' => 'TCM BASIC THEORY',
////            'language' => 'en',
////        ]);
////        $course->save();
//
//        Chapter::query()->where('course_id', $course->id)->delete();
//        Video::query()->where('course_id', $course->id)->delete();
//        //创建章节
////        $sections = array_unique(array_column($videos, 'section'));
//        foreach ($videos as $section => $video) {
//            $chater = Chapter::query()->updateOrCreate([
//                'course_id' => $course->id,
//                'title' => str_replace('.mp4', '', $video[0]['video']),
//                'language' => 'en',
//            ], [
//                'status' => ModelStatusEnum::OK
//            ]);
//            foreach ($video as $item) {
//
//                $resource = Resource::query()->updateOrCreate([
//                    'name' => $item['video'],
//                    'original_name' => $item['video'],
//                    'path' => $item['video_path'],
//                ], [
//                    'disk' => 'qiniu',
//                    'url' => 'http://zhongma.qiniu.xmnk.cn/' . $item['video_path'],
//                    'size' => 0,
//                    'language' => 'en',
//                    'status' => ModelStatusEnum::OK,
//                ]);
//                $subtitle_resource = null;
//                if ($item['srt']) {
//                    $subtitle_resource = Resource::query()->updateOrCreate([
//                        'path' => $item['srt'],
//                    ], [
//                        'name' => Str::random(8) . '.srt',
//                        'original_name' => $item['srt'],
//                        'disk' => 'public',
//                        'url' => 'http://zmzjzyyzx.hactcm.edu.cn/storage/' . $item['srt_path'],
//                        'size' => 0,
//                        'language' => 'en',
//                        'status' => ModelStatusEnum::OK,
//                    ]);
//                }
//
//                Video::query()->updateOrCreate([
//                    'course_id' => $course->id,
//                    'course_chapter_id' => $chater->id,
//                    'title' => $item['video'],
//                ], [
//                    'slug' => Str::random(),
//                    'language' => 'en',
//                    'url' => $resource->id,
//                    'published_at' => Carbon::now()->toDateTimeString(),
//                    'subtitle_zh_path' => $subtitle_resource ? $subtitle_resource->id : '',
//                    'subtitle_en_path' => $subtitle_resource ? $subtitle_resource->id : '',
//                    'status' => ModelStatusEnum::OK
//                ]);
//            }
//        }


//        $s_courses = "《中医基础理论》片花.mp4&0 Preface of Learing（序言）.mp4&1.1 Breif History of TCM Theory System（中医理论体系简史）.mp4&1.2 Wholism Concept（整体观念）.mp4&1.3 Treatment Based on Syndrome Differentiation（辨证论治）.mp4&2.1 Concept and Theory Contents of Yin-Yang（阴阳概念及阴阳学说内容）.mp4&2.2 Application of Yin-Yang Theory in Chinese Medicine（阴阳学说的应用）.mp4&2.3 Notion of the Five Elements（五行概念）.mp4&2.4 Application of the Five Elements Theory in Chinese Medicine（五行学说的应用）.mp4&3.1 Visceral Picture Theory Overview（藏象概述）.mp4&3.2 The Heart（心）.mp4&3.3 The Lung（肺）.mp4&3.4 The Spleen（脾）.mp4&3.5 The Liver（肝）.mp4&3.6 The Kidney.mp4&3.7 The Six Fu Organs（六腑）.mp4&4.1 Qi（气）.mp4&4.2 The Blood（血）.mp4&4.3 Body Fluid（津液）.mp4&4.4 Relationships among Qi, Blood, and Body Fluid（气血津液的相互关系）.mp4&5.1 Overview of the Meridian System（经络学说概述）.mp4&5.2 The Twelve Meridians（十二经脉）.mp4&5.3 The Eight Extraordinary Meridians（奇经八脉）.mp4&6.0 Constitution Theory（体质）.mp4&7.1 Etiology Introduction（病因概述）.mp4&7.10  Improper Diet and Maladjustment of Work and Leisure（饮食失宜及劳逸失度）.mp4&7.11 Phlegm and Stagnant Fluid（痰饮）.mp4&7.12 Stagnant Blood（瘀血）.mp4&7.2 Wind Pathogen（风邪）.mp4&7.3 Cold Pathogen（寒邪）.mp4&7.4 Summer-heat Pathogen（暑邪）.mp4&7.5 Dampness Pathogen（湿邪）.mp4&7.6 Dryness Pathogen（燥邪）.mp4&7.7 Fire Pathogen（火邪）.mp4&7.8 Pestilent Pathogens（疠气）.mp4&7.9 Endogenous Seven Affects（内伤七情）.mp4&8.1 Basic Pathogenesis I（病机一）.mp4&8.2 Basic Pathogenesis II（病机二）.mp4&9.1 Principles for Prevention of Disease（预防）.mp4&9.2 Principles for Treatment of  Disease（治则）.mp4";
//        $courses = [];
//
//        foreach (str2arr($s_courses, '&') as $key => $course) {
////            $courses[$key]['section'] = is_numeric(substr($course, 0, 1)) ? substr($course, 0, 1) : 0;
////            $courses[$key]['path'] = "zhongyijichulilun-20220905/" . $course;
////            $courses[$key]['name'] = $course;
//            $item['section'] = is_numeric(substr($course, 0, 1)) ? substr($course, 0, 1) : 0;
//            $item['path'] = "zhongyijichulilun-20220905/" . $course;
//            $item['name'] = $course;
//            $courses[$item['section']][] = $item;
//        }
//        //创建课程
////        $course = Course::query()->updateOrCreate([
////            'title' => 'TCM BASIC THEORY',
////            'language' => 'en',
////        ], [
////            'status' => ModelStatusEnum::OK
////        ]);
//
//        $course = Course::query()->where('id', 1)->first();
//
//
//        $chaters = Chapter::query()->where('course_id', $course->id)->orderBy('id')->get()->toArray();
//        Video::query()->where('course_id', $course->id)->delete();
//        foreach ($courses as $key => $video) {
////            $chater = Chapter::query()->updateOrCreate([
////                'course_id' => $course->id,
////                'title' => str_replace('.mp4', '', $video[0]['name']),
////                'language' => 'en',
////            ], [
////                'status' => ModelStatusEnum::OK
////            ]);
//
//            $chater = $chaters[$key];
//            foreach ($video as $item) {
//                $resource = Resource::query()->updateOrCreate([
//                    'name' => $item['name'],
//                    'original_name' => $item['name'],
//                    'path' => $item['path'],
//                ], [
//                    'disk' => 'qiniu',
//                    'url' => 'http://zhongma.qiniu.xmnk.cn/' . $item['path'],
//                    'size' => 0,
////                    'language' => 'en',
//                    'language' => 'zh_CN',
//                    'status' => ModelStatusEnum::OK,
//                ]);
//                $subtitle_resource = null;
//
//                Video::query()->updateOrCreate([
//                    'course_id' => $course->id,
//                    'course_chapter_id' => $chater['id'],
//                    'title' => $item['name'],
//                ], [
//                    'slug' => Str::random(),
////                    'language' => 'en',
//                    'language' => 'zh_CN',
//                    'url' => $resource->id,
//                    'published_at' => Carbon::now()->toDateTimeString(),
//                    'subtitle_zh_path' => $subtitle_resource ? $subtitle_resource->id : '',
//                    'subtitle_en_path' => $subtitle_resource ? $subtitle_resource->id : '',
//                    'status' => ModelStatusEnum::OK
//                ]);
//            }
//        }

        $course_id = 11;
        $to_course_id = 12;
//        $chapters = Chapter::query()->where('course_id', $course_id)->where('status', ModelStatusEnum::OK)->get();
//        foreach ($chapters as $chapter) {
//            $da = $chapter->toArray();
//            unset($da['id']);
//            $da['course_id'] = $to_course_id;
//            $da['language'] = 'en';
//            Chapter::query()->create($da);
//        }

        $chapters = Video::query()->where('course_id', $course_id)->where('status', ModelStatusEnum::OK)->get();
        foreach ($chapters as $chapter) {
            $da = $chapter->toArray();
            unset($da['id']);
            $da['course_id'] = $to_course_id;
            $da['language'] = 'en';
            Video::query()->create($da);
        }
    }

    public function pipe()
    {
        for ($i = 0; $i < 20; $i++) {
            $this->line($this->isActionAllowed("110", "reply", 60, 5)); //执行可以发现只有前5次是通过的
        }
    }

    private function isActionAllowed($userId, $action, $period, $maxCount)
    {
        $redis = Redis::connection();
        $key = sprintf('hist:%s:%s', $userId, $action);
        $now = $this->msectime();   # 毫秒时间戳

        $pipe = $redis->multi(\Redis::PIPELINE); //使用管道提升性能
        $pipe->zadd($key, $now, $now); //value 和 score 都使用毫秒时间戳
        $pipe->zremrangebyscore($key, 0, $now - $period * 1000); //移除时间窗口之前的行为记录，剩下的都是时间窗口内的
        $pipe->zcard($key);  //获取窗口内的行为数量
        $pipe->expire($key, $period + 1);  //多加一秒过期时间
        $replies = $pipe->exec();
        return $replies[2] <= $maxCount;
    }

    private function msectime()
    {
        list($msec, $sec) = explode(' ', microtime());
        $msectime = (float)sprintf('%.0f', (floatval($msec) + floatval($sec)) * 1000);
        return $msectime;
    }

    public function srt2vtt($str)
    {
        return str_replace('.srt', '.vtt', $str);
    }

    public function number($str)
    {
        return preg_replace('/[^\.0123456789]/s', '', $str);
    }

    public function getNumber($str)
    {
        $arr = explode('-', $str);
        return (int)$arr[0] . '.' . (int)$arr[1] . '.' . (int)$arr[2];
    }
}
