<?php

namespace App\Repositories\Criteria\Lab;

use Illuminate\Http\Request;
use Prettus\Repository\Contracts\CriteriaInterface;
use Prettus\Repository\Contracts\RepositoryInterface;

/**
 * Class AccountApplyCriteria.
 *
 * @package namespace App\Repositories\Criteria\Lab;
 */
class AccountApplyCriteria implements CriteriaInterface
{
    private $request;

    public function __construct(Request $request = null)
    {
        if (is_null($request)) {
            $this->request = \request();
        } else {
            $this->request = $request;
        }
    }

    /**
     * Apply criteria in query repository
     *
     * @param string $model
     * @param RepositoryInterface $repository
     *
     * @return mixed
     */
    public function apply($model, RepositoryInterface $repository)
    {
        if ($this->request->filled('name')) {
            $name = $this->request->get('name');
            $model = $model->where('name', 'like', "%{$name}%");
        }

        if ($this->request->filled('department')) {
            $department = $this->request->get('department');
            $model = $model->where('department', 'like', "%{$department}%");
        }

        if ($this->request->filled('mobile')) {
            $mobile = $this->request->get('mobile');
            $model = $model->where('mobile', 'like', "%{$mobile}%");
        }

        if ($this->request->filled('account')) {
            $account = $this->request->get('account');
            $model = $model->where('account', 'like', "%{$account}%");
        }

        if ($this->request->filled('check_status')) {
            $check_status = $this->request->get('check_status');
            $model = $model->where('check_status', '=', $check_status);
        }

        if ($this->request->filled('status')) {
            $status = $this->request->get('status');
            $model = $model->where('status', '=', $status);
        }

        $model = $model->orderByDesc('id');
        return $model;
    }
}
