<?php

namespace App\Repositories\Eloquent\Base;

use App\Repositories\Criteria\Base\SettingCriteria;
use App\Repositories\Presenters\Base\SettingPresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\Base\SettingRepository;
use App\Repositories\Models\Base\Setting;
use App\Repositories\Validators\Base\SettingValidator;

/**
 * Class SettingRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\Base;
 */
class SettingRepositoryEloquent extends BaseRepository implements SettingRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return Setting::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {

        return SettingValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(SettingCriteria::class));
        $this->setPresenter(SettingPresenter::class);
    }

}
