<?php

namespace App\Repositories\Eloquent\Dianli;

use App\Repositories\Criteria\Dianli\TaskCriteria;
use App\Repositories\Presenters\Dianli\TaskPresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\Dianli\TaskRepository;
use App\Repositories\Models\Dianli\Task;
use App\Repositories\Validators\Dianli\TaskValidator;

/**
 * Class TaskRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\Dianli;
 */
class TaskRepositoryEloquent extends BaseRepository implements TaskRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return Task::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {

        return TaskValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(TaskCriteria::class));
        $this->setPresenter(TaskPresenter::class);
    }

}
