<?php

namespace App\Repositories\Eloquent\Lab;

use App\Repositories\Criteria\Lab\AccountApplyCriteria;
use App\Repositories\Presenters\Lab\AccountApplyPresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\Lab\AccountApplyRepository;
use App\Repositories\Models\Lab\AccountApply;
use App\Repositories\Validators\Lab\AccountApplyValidator;

/**
 * Class AccountApplyRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\Lab;
 */
class AccountApplyRepositoryEloquent extends BaseRepository implements AccountApplyRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return AccountApply::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {
        return AccountApplyValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(AccountApplyCriteria::class));
        $this->setPresenter(AccountApplyPresenter::class);
    }

}
