<?php

namespace App\Repositories\Eloquent\Lab;

use App\Repositories\Criteria\Lab\ImportRecordCriteria;
use App\Repositories\Presenters\Lab\ImportRecordPresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\Lab\ImportRecordRepository;
use App\Repositories\Models\Lab\ImportRecord;
use App\Repositories\Validators\Lab\ImportRecordValidator;

/**
 * Class ImportRecordRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\Lab;
 */
class ImportRecordRepositoryEloquent extends BaseRepository implements ImportRecordRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return ImportRecord::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {

        return ImportRecordValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(ImportRecordCriteria::class));
        $this->setPresenter(ImportRecordPresenter::class);
    }

}
