<?php

namespace App\Repositories\Eloquent\Lab;

use App\Repositories\Criteria\Lab\MaintainCriteria;
use App\Repositories\Presenters\Lab\MaintainPresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\Lab\MaintainRepository;
use App\Repositories\Models\Lab\Maintain;
use App\Repositories\Validators\Lab\MaintainValidator;

/**
 * Class MaintainRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\Lab;
 */
class MaintainRepositoryEloquent extends BaseRepository implements MaintainRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return Maintain::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {

        return MaintainValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(MaintainCriteria::class));
        $this->setPresenter(MaintainPresenter::class);
    }

}
