<?php

namespace App\Repositories\Eloquent\Lab;

use App\Repositories\Criteria\Lab\OpenAppointmentCriteria;
use App\Repositories\Presenters\Lab\OpenAppointmentPresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\Lab\OpenAppointmentRepository;
use App\Repositories\Models\Lab\OpenAppointment;
use App\Repositories\Validators\Lab\OpenAppointmentValidator;

/**
 * Class OpenAppointmentRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\Lab;
 */
class OpenAppointmentRepositoryEloquent extends BaseRepository implements OpenAppointmentRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return OpenAppointment::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {

        return OpenAppointmentValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(OpenAppointmentCriteria::class));
        $this->pushCriteria(app(RequestCriteria::class));
        $this->setPresenter(OpenAppointmentPresenter::class);
    }

}
