<?php

namespace App\Repositories\Eloquent\News;

use App\Repositories\Criteria\News\NoticeCriteria;
use App\Repositories\Presenters\News\NoticePresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\News\NoticeRepository;
use App\Repositories\Models\News\Notice;
use App\Repositories\Validators\News\NoticeValidator;

/**
 * Class NoticeRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\News;
 */
class NoticeRepositoryEloquent extends BaseRepository implements NoticeRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return Notice::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {

        return NoticeValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(NoticeCriteria::class));
        $this->setPresenter(NoticePresenter::class);
    }

}
