<?php

namespace App\Repositories\Eloquent\School;

use App\Repositories\Criteria\School\GradeCriteria;
use App\Repositories\Presenters\School\GradePresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\School\GradeRepository;
use App\Repositories\Models\School\Grade;

/**
 * Class GradeRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\School;
 */
class GradeRepositoryEloquent extends BaseRepository implements GradeRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return Grade::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(GradeCriteria::class));
        $this->setPresenter(GradePresenter::class);
    }

}
