<?php

namespace App\Repositories\Eloquent\School;

use App\Repositories\Criteria\School\ScheduleApproveRecordCriteria;
use App\Repositories\Presenters\School\ScheduleApproveRecordPresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\School\ScheduleApproveRecordRepository;
use App\Repositories\Models\School\ScheduleApproveRecord;
use App\Repositories\Validators\School\ScheduleApproveRecordValidator;

/**
 * Class ScheduleApproveRecordRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\School;
 */
class ScheduleApproveRecordRepositoryEloquent extends BaseRepository implements ScheduleApproveRecordRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return ScheduleApproveRecord::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {

        return ScheduleApproveRecordValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(ScheduleApproveRecordCriteria::class));
        $this->setPresenter(ScheduleApproveRecordPresenter::class);
    }

}
