<?php

namespace App\Repositories\Eloquent\School;

use App\Repositories\Criteria\School\TeacherCriteria;
use App\Repositories\Presenters\School\TeacherPresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\School\TeacherRepository;
use App\Repositories\Models\School\Teacher;
use App\Repositories\Validators\School\TeacherValidator;

/**
 * Class TeacherRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\School;
 */
class TeacherRepositoryEloquent extends BaseRepository implements TeacherRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return Teacher::class;
    }

    /**
     * Specify Validator class name
     *
     * @return mixed
     */
    public function validator()
    {

        return TeacherValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(RequestCriteria::class));
        $this->pushCriteria(app(TeacherCriteria::class));
        $this->setPresenter(TeacherPresenter::class);
    }

}
