<?php

namespace App\Repositories\Eloquent\School;

use App\Repositories\Criteria\School\TimeCriteria;
use App\Repositories\Presenters\School\TimePresenter;
use Prettus\Repository\Eloquent\BaseRepository;
use Prettus\Repository\Criteria\RequestCriteria;
use App\Contracts\Repositories\School\TimeRepository;
use App\Repositories\Models\School\Time;
use App\Repositories\Validators\School\TimeValidator;

/**
 * Class TimeRepositoryEloquent.
 *
 * @package namespace App\Repositories\Eloquent\School;
 */
class TimeRepositoryEloquent extends BaseRepository implements TimeRepository
{
    /**
     * Specify Model class name
     *
     * @return string
     */
    public function model()
    {
        return Time::class;
    }

    /**
    * Specify Validator class name
    *
    * @return mixed
    */
    public function validator()
    {
        return TimeValidator::class;
    }


    /**
     * Boot up the repository, pushing criteria
     */
    public function boot()
    {
        $this->pushCriteria(app(TimeCriteria::class));
        $this->pushCriteria(app(RequestCriteria::class));
        $this->setPresenter(TimePresenter::class);
    }

}
