<?php

namespace App\Repositories\Models\Base;

use App\Repositories\Models\Model;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Support\Facades\App;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class Resource.
 *
 * @package namespace App\Repositories\Models;
 */
class Resource extends Model implements Transformable
{
    protected $table = 'base_resources';
    use TransformableTrait;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = ['name', 'original_name', 'path', 'disk', 'url', 'size', 'status'];

    protected static function booted()
    {
//        $language = request()->header('language', App::getLocale());
//        switch ($language) {
//            case 'zh_CN':
//            default:
//                $language = 'zh_CN';
//                break;
//            case 'en':
//                $language = 'en';
//                break;
//        }
//        static::addGlobalScope('language', function (Builder $builder) use ($language) {
//            $builder->where('language', $language);
//        });
//
//        static::creating(function ($model) use ($language) {
//            if (!(in_array('language', array_keys($model->attributes)) && !empty($model->attributes['language']))) {
//                $model->language = $language;
//            }
//        });
    }

    public function getUrlAttribute($val)
    {
        if (isset($this->attributes['disk']) && $this->attributes['disk'] == 'public') {
            return path_to_url($this->attributes['path']);
        }
        return $val;
    }

}
