<?php

namespace App\Repositories\Models\Lab;

use App\Repositories\Models\Base\Admin;
use Illuminate\Database\Eloquent\Model;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class AccountApply.
 *
 * @package namespace App\Repositories\Models\Lab;
 */
class AccountApply extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'lab_account_applies';

    protected $casts = [
        'roles' => 'array'
    ];
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];

    public function check_admin()
    {
        return $this->belongsTo(Admin::class)->select(['id', 'username', 'name']);
    }

}
