<?php

namespace App\Repositories\Models\Lab;

use App\Repositories\Models\Base\Admin;
use App\Repositories\Models\Model;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class ImportRecord.
 *
 * @package namespace App\Repositories\Models\Lab;
 */
class ImportRecord extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'lab_import_records';

    protected $casts = [
        'message' => 'array'
    ];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];

    public function admin()
    {
        return $this->belongsTo(Admin::class)->select(['id', 'name']);
    }

    protected static function booted()
    {
        static::deleted(function (ImportRecord $model) {
            Schedule::query()->where('import_record_id', $model->id)->delete();
        });
    }

}
