<?php

namespace App\Repositories\Models\Lab;

use App\Repositories\Models\Base\Admin;
use App\Repositories\Models\Base\Resource;
use App\Repositories\Models\Model;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class OpenAppointment.
 *
 * @package namespace App\Repositories\Models\Lab;
 */
class OpenAppointment extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'lab_open_appointments';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];

    protected $casts = [
        'use_data' => 'array',
        'enclosure' => 'json',
    ];

    public function admin()
    {
        return $this->belongsTo(Admin::class)->select(['id', 'name', 'username']);
    }

    public function getEnclosureResourceAttribute()
    {
        $enclosure = $this->fromJson($this->attributes['enclosure']);
        if (is_array($enclosure)) {
            return Resource::query()->whereIn('id', $enclosure)->select(['id', 'path', 'url'])->get();
        }
        return [];
    }
}
