<?php

namespace App\Repositories\Models\News;

use App\Repositories\Models\Base\Admin;
use Illuminate\Database\Eloquent\Model;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class Message.
 *
 * @package namespace App\Repositories\Models\News;
 */
class Message extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'news_messages';

    protected $casts = [
        'user_ids' => 'array',
        'send_type' => 'array',
    ];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];

    public function admin()
    {
        return $this->belongsTo(Admin::class)->select(['id', 'username', 'name']);
    }

    public function getUsersAttribute()
    {
        return Admin::query()->whereIn('id', $this->fromJson($this->attributes['user_ids']))->select(['id', 'username', 'name', 'mobile', 'email'])->get();
    }

    public function resource()
    {
        return $this->morphTo()->select(['id', 'name', 'body']);
    }

}
