<?php

namespace App\Repositories\Models\News;

use App\Repositories\Models\Base\Admin;
use Illuminate\Database\Eloquent\Model;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class Notice.
 *
 * @package namespace App\Repositories\Models\News;
 */
class Notice extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'news_notices';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [
        'tags' => 'array'
    ];

    public function setTagsAttribute($val)
    {
        $this->attributes['tags'] = '-' . arr2str($val, '-') . '-';
    }

    public function getTagsAttribute($val)
    {
        return str2arr(trim($val, '-'), '-');
    }

    public function admin()
    {
        return $this->belongsTo(Admin::class)->select(['id', 'name', 'username']);
    }


}
