<?php

namespace App\Repositories\Models\News;

use App\Repositories\Models\Base\Admin;
use Illuminate\Database\Eloquent\Model;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class Message.
 *
 * @package namespace App\Repositories\Models\News;
 */
class UserMessage extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'news_user_messages';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];

    public function admin()
    {
        return $this->belongsTo(Admin::class)->select(['id', 'username', 'name']);
    }

    public function resource()
    {
        return $this->morphTo()->select(['id', 'name', 'body']);
    }
}
