<?php

namespace App\Repositories\Models\School;

use App\Repositories\Models\Base\Admin;
use App\Repositories\Models\Model;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class ScheduleApproveRecord.
 *
 * @package namespace App\Repositories\Models\School;
 */
class ScheduleApproveRecord extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'school_schedule_approve_records';

    protected $casts = [
        'schedule_data' => 'array',
        'migrate_data' => 'array',
        'operation_data' => 'array',
    ];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];

    public function lesson()
    {
        return $this->belongsTo(Lesson::class)->select(['id', 'name']);
    }

    public function teacher()
    {
        return $this->belongsTo(Teacher::class)->select(['id', 'name', 'account']);
    }

    public function schedule()
    {
        return $this->belongsTo(LessonSchedule::class, 'lesson_schedule_id')->select(['id', 'teach_title']);
    }

    public function admin()
    {
        return $this->belongsTo(Admin::class)->select(['id', 'name']);
    }

    public function room()
    {
        return $this->belongsTo(Room::class)->select(['id', 'name']);
    }

}
