<?php

namespace App\Repositories\Models\School;

use App\Repositories\Enums\ModelStatusEnum;
use App\Repositories\Models\Model;
use Carbon\Carbon;
use Illuminate\Support\Facades\Cache;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class Term.
 *
 * @package namespace App\Repositories\Models\Mentor;
 */
class Term extends Model implements Transformable
{
    use TransformableTrait;

    protected $table = 'school_terms';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];


    public static function byId($id)
    {
        return Cache::remember('model:school:term:byId:' . $id, Carbon::now()->addDays(1), function () use ($id) {
            return self::query()->where('id', '=', $id)->first();
        });
    }

}
