<?php

namespace App\Repositories\Models\School;

use App\Repositories\Models\Model;
use Carbon\Carbon;
use Prettus\Repository\Contracts\Transformable;
use Prettus\Repository\Traits\TransformableTrait;

/**
 * Class Time.
 *
 * @package namespace App\Repositories\Models\Mentor;
 */
class Time extends Model implements Transformable
{
    use TransformableTrait;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [];

    protected $table = 'school_times';

    public function getStartTimeAttribute($val)
    {
        return Carbon::parse($val)->format("H:i");
    }

    public function getEndTimeAttribute($val)
    {
        return Carbon::parse($val)->format("H:i");
    }

    public static function byIdGetBaseInfo($id)
    {
        return self::query()->where('id', $id)->select(['id', 'name'])->first();
    }

    public static function byId($id)
    {
        return self::query()->where('id', $id)->first();
    }

    public static function byIdGetHour($id)
    {
        $time = self::byId($id);
        if ($time) {
            $a = str2arr($time->section, '-');
            return $a[1] - $a[0] + 1;
        }
        return 0;
    }

}
