<?php

namespace App\Repositories\Transformers\Lab;

use App\Repositories\Enums\Lab\ImportStatusEnum;
use Carbon\Carbon;
use League\Fractal\TransformerAbstract;
use App\Repositories\Models\Lab\ImportRecord;

/**
 * Class ImportRecordTransformer.
 *
 * @package namespace App\Repositories\Transformers\Lab;
 */
class ImportRecordTransformer extends TransformerAbstract
{
    /**
     * Transform the ImportRecord entity.
     *
     * @param \App\Repositories\Models\Lab\ImportRecord $model
     *
     * @return array
     */
    public function transform(ImportRecord $model)
    {
        return [
            'id' => $model->id,
            'name' => $model->name,
            'type' => $model->type,
            'body' => $model->body,
            'admin' => $model->admin,
            'message' => $model->message,
            'status' => $model->status,
            'status_text' => ImportStatusEnum::getDescription($model->status),
            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
            'updated_at' => $model->updated_at->format(Carbon::DEFAULT_TO_STRING_FORMAT)
        ];
    }
}
