<?php

namespace App\Repositories\Transformers\Lab;

use App\Repositories\Enums\Lab\OpenAppointmentStatusEnum;
use Carbon\Carbon;
use League\Fractal\TransformerAbstract;
use App\Repositories\Models\Lab\OpenAppointment;

/**
 * Class OpenAppointmentTransformer.
 *
 * @package namespace App\Repositories\Transformers\Lab;
 */
class OpenAppointmentTransformer extends TransformerAbstract
{
    /**
     * Transform the OpenAppointment entity.
     *
     * @param \App\Repositories\Models\Lab\OpenAppointment $model
     *
     * @return array
     */
    public function transform(OpenAppointment $model)
    {
        return [
            'id' => (int)$model->id,
            'template' => $model->template,
            'department' => $model->department,
            'use_data' => $model->use_data,
            'use_reason' => $model->use_reason,
            'use_need' => $model->use_need,
            'use_people_nums' => $model->use_people_nums,
            'applicant_name' => $model->applicant_name,
            'applicant_mobile' => $model->applicant_mobile,
            'enclosure' => $model->enclosure,
            'enclosure_resource' => $model->enclosureResource,
            'status' => $model->status,
            'status_text' => OpenAppointmentStatusEnum::getDescription($model->status),
            'admin' => $model->admin,
            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
            'updated_at' => $model->updated_at->format(Carbon::DEFAULT_TO_STRING_FORMAT)
        ];
    }
}
