<?php

namespace App\Repositories\Transformers\News;

use Carbon\Carbon;
use League\Fractal\TransformerAbstract;
use App\Repositories\Models\News\Message;

/**
 * Class MessageTransformer.
 *
 * @package namespace App\Repositories\Transformers\News;
 */
class MessageTransformer extends TransformerAbstract
{
    /**
     * Transform the Message entity.
     *
     * @param \App\Repositories\Models\News\Message $model
     *
     * @return array
     */
    public function transform(Message $model)
    {
        return [
            'id' => (int)$model->id,
            'name' => $model->name,
            'type' => $model->type,
            'resource_type' => $model->resource_type,
            'resource_id' => $model->resource_id,
            'user_ids' => $model->user_ids,
            'users' => $model->users,
            'admin' => $model->admin,
            'send_type' => $model->send_type,
            'send_time' => $model->send_time,
            'message' => $model->message,
            'status' => $model->status,
            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
            'updated_at' => $model->updated_at->format(Carbon::DEFAULT_TO_STRING_FORMAT)
        ];
    }
}
