<?php

namespace App\Repositories\Transformers\News;

use App\Repositories\Transformers\BaseTransformer;
use Carbon\Carbon;
use League\Fractal\TransformerAbstract;
use App\Repositories\Models\News\Notice;

/**
 * Class NoticeTransformer.
 *
 * @package namespace App\Repositories\Transformers\News;
 */
class NoticeTransformer extends BaseTransformer
{
    /**
     * Transform the Notice entity.
     *
     * @param \App\Repositories\Models\News\Notice $model
     *
     * @return array
     */
    public function lists($model)
    {
        return [
            'id' => (int)$model->id,
            'name' => $model->name,
//            'type' => $model->type,
            'description' => $model->description,
            'tags' => $model->tags,
//            'body' => $model->body,
            'view_count' => $model->view_count,
            'good_count' => $model->good_count,
            'admin' => $model->admin,
            'sort' => $model->sort,
            'status' => $model->status,
//            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
            'updated_at' => $model->updated_at->format(Carbon::DEFAULT_TO_STRING_FORMAT)
        ];
    }

    public function detail($model)
    {
        return [
            'id' => (int)$model->id,
            'name' => $model->name,
//            'type' => $model->type,
            'description' => $model->description,
            'tags' => $model->tags,
            'body' => $model->body,
            'view_count' => $model->view_count,
            'good_count' => $model->good_count,
            'admin' => $model->admin,
            'sort' => $model->sort,
            'status' => $model->status,
            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
            'updated_at' => $model->updated_at->format(Carbon::DEFAULT_TO_STRING_FORMAT)
        ];
    }
}
