<?php

namespace App\Repositories\Transformers\School;

use App\Repositories\Enums\School\LessonScheduleApproveStatusEnum;
use App\Repositories\Transformers\BaseTransformer;
use Carbon\Carbon;

/**
 * Class ScheduleApproveRecordTransformer.
 *
 * @package namespace App\Repositories\Transformers\School;
 */
class ScheduleApproveRecordTransformer extends BaseTransformer
{
    /**
     * Transform the ScheduleApproveRecord entity.
     *
     * @param \App\Repositories\Models\School\ScheduleApproveRecord $model
     *
     * @return array
     */
    public function lists($model)
    {
        return [
            'id' => (int)$model->id,
            'lesson' => $model->lesson,
            'teacher' => $model->teacher,
            'lesson_schedule_id' => $model->lesson_schedule_id,
            'schedule_data' => $model->schedule_data,
            'type' => $model->type,
            'source_type' => $model->source_type,
            'migrate_data' => $model->migrate_data,
            'admin' => $model->admin,
            'status' => $model->status,
            'status_text' => LessonScheduleApproveStatusEnum::getDescription($model->status),
            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
        ];
    }

    public function detail($model)
    {
        return [
            'id' => (int)$model->id,
            'lesson' => $model->lesson,
            'teacher' => $model->teacher,
            'lesson_schedule_id' => $model->lesson_schedule_id,
            'schedule_data' => $model->schedule_data,
            'type' => $model->type,
            'source_type' => $model->source_type,
            'body' => $model->body,
            'migrate_data' => $model->migrate_data,
            'admin' => $model->admin,
            'status' => $model->status,
            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
            'updated_at' => $model->updated_at->format(Carbon::DEFAULT_TO_STRING_FORMAT)
        ];
    }
}
