<?php

namespace App\Repositories\Transformers\School;

use Carbon\Carbon;
use League\Fractal\TransformerAbstract;
use App\Repositories\Models\School\Term;

/**
 * Class TermTransformer.
 *
 * @package namespace App\Repositories\Transformers\School;
 */
class TermTransformer extends TransformerAbstract
{
    /**
     * Transform the Term entity.
     *
     * @param \App\Repositories\Models\School\Term $model
     *
     * @return array
     */
    public function transform(Term $model)
    {
        return [
            'id' => (int)$model->id,
            'name' => $model->name,
            'start_date' => $model->start_date,
            'end_date' => $model->end_date,
            'weeks' => $model->weeks,
            'status' => $model->status,
            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
            'updated_at' => $model->updated_at->format(Carbon::DEFAULT_TO_STRING_FORMAT)
        ];
    }
}
