<?php

namespace App\Repositories\Transformers\School;

use App\Repositories\Enums\School\TimeTypeEnum;
use Carbon\Carbon;
use League\Fractal\TransformerAbstract;
use App\Repositories\Models\School\Time;

/**
 * Class TimeTransformer.
 *
 * @package namespace App\Repositories\Transformers\School;
 */
class TimeTransformer extends TransformerAbstract
{
    /**
     * Transform the Time entity.
     *
     * @param \App\Repositories\Models\School\Time $model
     *
     * @return array
     */
    public function transform(Time $model)
    {
        return [
            'id' => (int)$model->id,
            'name' => $model->name,
            'section' => $model->section,
            'start_time' => $model->start_time,
            'end_time' => $model->end_time,
            'type' => $model->type,
            'type_name' => TimeTypeEnum::getDescription($model->type),
            'sort' => $model->sort,
            'status' => $model->status,

            'created_at' => $model->created_at->format(Carbon::DEFAULT_TO_STRING_FORMAT),
            'updated_at' => $model->updated_at->format(Carbon::DEFAULT_TO_STRING_FORMAT)
        ];
    }
}
