<?php

namespace App\Repositories\Validators\Lab;

use \Prettus\Validator\Contracts\ValidatorInterface;
use \Prettus\Validator\LaravelValidator;

/**
 * Class AccountApplyValidator.
 *
 * @package namespace App\Repositories\Validators\Lab;
 */
class AccountApplyValidator extends LaravelValidator
{
    /**
     * Validation Rules
     *
     * @var array
     */
    protected $rules = [
        ValidatorInterface::RULE_CREATE => [
            'account' => 'required',
            'name' => 'required',
            'mobile' => 'required|mobile',
            'email' => 'required|email',
            'department' => 'required',
            'password' => 'required|confirmed',
            'status' => 'sometimes',
        ],
        ValidatorInterface::RULE_UPDATE => [
            'account' => 'required',
            'name' => 'required',
            'mobile' => 'required|mobile',
            'email' => 'required|email',
            'department' => 'required',
            'password' => 'required|confirmed',
            'roles' => 'sometimes|nullable',
            'status' => 'sometimes',
        ],
    ];
}
