<?php

namespace App\Repositories\Validators\Lab;

use \Prettus\Validator\Contracts\ValidatorInterface;
use \Prettus\Validator\LaravelValidator;

/**
 * Class OpenAppointmentValidator.
 *
 * @package namespace App\Repositories\Validators\Lab;
 */
class OpenAppointmentValidator extends LaravelValidator
{
    /**
     * Validation Rules
     *
     * @var array
     */
    protected $rules = [
        ValidatorInterface::RULE_CREATE => [
            'admin_id' => 'sometimes|integer',
            'term_id' => 'sometimes|integer',
            'template' => 'required|integer',
            'use_data' => 'required|array',
            'use_reason' => 'required',
            'use_need' => 'sometimes|nullable',
            'use_people_nums' => 'required',
            'applicant_name' => 'required',
            'applicant_mobile' => 'required',
            'enclosure' => 'sometimes',
            'department' => 'required',
        ],
        ValidatorInterface::RULE_UPDATE => [
            'use_data' => 'required|array',
            'template' => 'required|integer',
            'use_reason' => 'required',
            'use_people_nums' => 'required',
            'use_need' => 'sometimes|nullable',
            'applicant_name' => 'required',
            'applicant_mobile' => 'required',
            'enclosure' => 'sometimes',
            'department' => 'required',
        ],
    ];
}
