<?php

namespace App\Repositories\Validators\News;

use \Prettus\Validator\Contracts\ValidatorInterface;
use \Prettus\Validator\LaravelValidator;

/**
 * Class MessageValidator.
 *
 * @package namespace App\Repositories\Validators\News;
 */
class MessageValidator extends LaravelValidator
{
    /**
     * Validation Rules
     *
     * @var array
     */
    protected $rules = [
        ValidatorInterface::RULE_CREATE => [
            'name' => 'required',
            'type' => 'sometimes|integer|in:1,2',
            'user_ids' => 'required|array',
            'send_type' => 'required|array',
            'send_time' => 'sometimes|nullable|date',
            'message' => 'sometimes|nullable',
            'resource_type' => 'sometimes|nullable',
            'resource_id' => 'sometimes|nullable|integer',
            'status' => 'sometimes|nullable|integer',
        ],
        ValidatorInterface::RULE_UPDATE => [
            'name' => 'required',
            'type' => 'sometimes|integer|in:1,2',
            'user_ids' => 'required|array|gte:1',
            'send_type' => 'required|array',
//            'send_time' => 'sometimes|nullable|time',
            'message' => 'sometimes|nullable',
            'resource_type' => 'sometimes|nullable',
            'resource_id' => 'sometimes|nullable|integer',
            'status' => 'sometimes|nullable|integer',
        ],
    ];
}
