<?php

namespace App\Repositories\Validators\School;

use \Prettus\Validator\Contracts\ValidatorInterface;
use \Prettus\Validator\LaravelValidator;

/**
 * Class ScheduleApproveRecordValidator.
 *
 * @package namespace App\Repositories\Validators\School;
 */
class ScheduleApproveRecordValidator extends LaravelValidator
{
    /**
     * Validation Rules
     *
     * @var array
     */
    protected $rules = [
        ValidatorInterface::RULE_CREATE => [
            'term_id' => 'required|integer',
            'lesson_id' => 'required|integer',
            'teacher_id' => 'required|integer',
            'lesson_schedule_id' => 'required|integer',
            'body' => 'sometimes|nullable',
            'type' => 'required|integer',
            'migrate_data' => 'sometimes|nullable',
            'status' => 'required|integer',
        ],
        ValidatorInterface::RULE_UPDATE => [
            'term_id' => 'required|integer',
            'lesson_id' => 'required|integer',
            'teacher_id' => 'required|integer',
            'lesson_schedule_id' => 'required|integer',
            'body' => 'sometimes|nullable',
            'type' => 'required|integer',
            'migrate_data' => 'sometimes|nullable',
            'status' => 'required|integer',
        ],
    ];
}
